// GniazdaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Gniazda.h"
#include "GniazdaDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGniazdaDlg dialog

CGniazdaDlg::CGniazdaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGniazdaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGniazdaDlg)
	m_strKomunikat = _T("");
	m_strNazwa = _T("");
	m_iPort = 0;
	m_iTyp = -1;
	m_strStrzalNaPole = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGniazdaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGniazdaDlg)
	DDX_Control(pDX, IDC_LWYSLANE, m_ctlWyslane);
	DDX_Control(pDX, IDC_PPOLACZ, m_ctlPolacz);
	DDX_Text(pDX, IDC_EKNKAT, m_strKomunikat);
	DDX_Text(pDX, IDC_ENAZWASWR, m_strNazwa);
	DDX_Text(pDX, IDC_EPORTSWR, m_iPort);
	DDX_Radio(pDX, IDC_OKLIENT, m_iTyp);
	DDX_Text(pDX, IDC_STRZALNAPOLE, m_strStrzalNaPole);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGniazdaDlg, CDialog)
	//{{AFX_MSG_MAP(CGniazdaDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OKLIENT, OnTypPo)
	ON_BN_CLICKED(IDC_PPOLACZ, OnPpolacz)
	ON_BN_CLICKED(IDC_PWYSLIJ, OnPwyslij)
	ON_BN_CLICKED(IDC_PZAMKNIJ, OnPzamknij)
	ON_BN_CLICKED(IDC_ZAMKNIJ, OnZamknij)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_OSERWER, OnTypPo)
	ON_BN_CLICKED(IDC_STRZAL, OnStrzal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGniazdaDlg message handlers

BOOL CGniazdaDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SetWindowText("Statki");
	m_iTyp=0;
	m_strNazwa="loopback";
	m_iPort=4000;
	z=0;
	klikniecia=0;
	StrzalOddanyNaPole=0;
	CzyOddanyStrzal=0;
	IleTrafionych=0;
	IleTrafionych1=0;
	wyswietl=FALSE;
	NastapiloPolaczenie=FALSE;
	AktywnePolePrzeciwnika=FALSE;
	kom="Uzyskaj polaczenie sieciowe z przeciwnikiem";
	UpdateData(FALSE);
	m_sGniazdoPolaczenia.UstawOjca(this);
	m_sGniazdoSluchajace.UstawOjca(this);
	inicjuj_pola();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGniazdaDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGniazdaDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);
		okno=&dc;
		RysujPola(&dc);
		Ustaw_statki(&dc);
		Komunikaty();
		if(wyswietl)
			NapisPoPolaczeniu();	
		if(z==20)
			 AktywujStrzal();
		ZaznaczStrzaly(&dc);
	
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGniazdaDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGniazdaDlg::OnTypPo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_iTyp==0)
		m_ctlPolacz.SetWindowText("Polacz");
	else
		m_ctlPolacz.SetWindowText("Sluchaj");
}

void CGniazdaDlg::OnPpolacz() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	GetDlgItem(IDC_PPOLACZ)->EnableWindow(FALSE);
	GetDlgItem(IDC_ENAZWASWR)->EnableWindow(FALSE);
	GetDlgItem(IDC_EPORTSWR)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATICNAZWA)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATICPORT)->EnableWindow(FALSE);
	GetDlgItem(IDC_OKLIENT)->EnableWindow(FALSE);
	GetDlgItem(IDC_OSERWER)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATICTYP)->EnableWindow(FALSE);
	if(m_iTyp==0)
	{
		m_sGniazdoPolaczenia.Create();
		m_sGniazdoPolaczenia.Connect(m_strNazwa,m_iPort);
	}
	else
	{
		m_sGniazdoSluchajace.Create(m_iPort);
		m_sGniazdoSluchajace.Listen();
	}
}

void CGniazdaDlg::OnAccept()
{
	m_sGniazdoSluchajace.Accept(m_sGniazdoPolaczenia);
	GetDlgItem(IDC_EKNKAT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PWYSLIJ)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATICKNKAT)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATICTYP)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_OKLIENT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_OSERWER)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATICNAZWA)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_ENAZWASWR)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATICPORT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EPORTSWR)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATICRAMKA)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_RAMKASTRZALU)->EnableWindow(FALSE);
	GetDlgItem(IDC_NAPISSTRZALU)->EnableWindow(FALSE);
	GetDlgItem(IDC_STRZALNAPOLE)->EnableWindow(FALSE);
	GetDlgItem(IDC_STRZAL)->EnableWindow(FALSE);
	kom="Nastapilo polaczenie, postaw statki na swojej planszy";
	wyswietl=TRUE;
	NastapiloPolaczenie=TRUE;
	Invalidate();
}

void CGniazdaDlg::OnConnect()
{
	GetDlgItem(IDC_EKNKAT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PWYSLIJ)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATICKNKAT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PZAMKNIJ)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATICTYP)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_OKLIENT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_OSERWER)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATICNAZWA)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_ENAZWASWR)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATICPORT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EPORTSWR)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATICRAMKA)->ShowWindow(SW_HIDE);
	kom="Nastapilo polaczenie, postaw statki na swojej planszy";
	wyswietl=TRUE;
	NastapiloPolaczenie=TRUE;
	Invalidate();
}

void CGniazdaDlg::OnSend()
{

}

void CGniazdaDlg::OnReceive()
{
	char *pBuf=new char[1025],*buf=new char[1025];
	int iBufRozm=1024;
	int iOdebrano;
	CString strOdebrany,s;


	iOdebrano=m_sGniazdoPolaczenia.Receive(pBuf,iBufRozm);
	if(iOdebrano==SOCKET_ERROR)
	{
		MessageBox("Problemy z siecia","Uwaga",MB_ICONINFORMATION);
	}
	else
	{
		pBuf[iOdebrano]=NULL;
		strOdebrany=pBuf;
		if((pBuf[0]=='0')&&(pBuf[1]=='0')&&(pBuf[2]=='0'))
		{	
			if(iOdebrano==6)
			{
				StrzalOddanyNaPole=(int(pBuf[3])-65)+90;
				CzyOddanyStrzal=1;
				if(wartosc_pola[StrzalOddanyNaPole]==2)
				{
					WartoscPolaTemp[StrzalOddanyNaPole]=2;
					IleTrafionych++;
					CzyTrafiony=TRUE;
				}
				else
				{
					WartoscPolaTemp[StrzalOddanyNaPole]=1;
					CzyTrafiony=FALSE;
				}
				Invalidate();
			}
			else
			{
				StrzalOddanyNaPole=(int(pBuf[3])-65)+(int(pBuf[4])-49)*10;
				CzyOddanyStrzal=1;
				if(wartosc_pola[StrzalOddanyNaPole]==2)
				{
					WartoscPolaTemp[StrzalOddanyNaPole]=2;
					IleTrafionych++;
					CzyTrafiony=TRUE;
				}
				else
				{
					WartoscPolaTemp[StrzalOddanyNaPole]=1;
					CzyTrafiony=FALSE;
				}
				Invalidate();
			}
			if(IleTrafionych==20)
				{
					MessageBox("Wlasnie przegrales te bitwe!","Koniec");
					Wyczysc();
				}
			if(CzyTrafiony)
			{
				GetDlgItem(IDC_RAMKASTRZALU)->EnableWindow(FALSE);
				GetDlgItem(IDC_STRZAL)->EnableWindow(FALSE);
				GetDlgItem(IDC_NAPISSTRZALU)->EnableWindow(FALSE);
				GetDlgItem(IDC_STRZALNAPOLE)->EnableWindow(FALSE);
			}
			else
			{
				GetDlgItem(IDC_RAMKASTRZALU)->EnableWindow(TRUE);
				GetDlgItem(IDC_STRZAL)->EnableWindow(TRUE);
				GetDlgItem(IDC_NAPISSTRZALU)->EnableWindow(TRUE);
				GetDlgItem(IDC_STRZALNAPOLE)->EnableWindow(TRUE);
			}
		}
		else if((pBuf[0]=='t')&&(pBuf[1]=='a')&&(pBuf[2]=='b')&&(pBuf[3]=='l')&&
			(pBuf[4]=='i')&&(pBuf[5]=='c')&&(pBuf[6]=='a'))
		{
			for(int i=7;i<107;i++)
			{
				if(pBuf[i]=='a')
					TablicaPrzeciwnikaWar[i-7]=2;	
				else
					TablicaPrzeciwnikaWar[i-7]=0;
			}
		}
	if((pBuf[0]=='k')&&(pBuf[1]=='k')&&(pBuf[2]=='k')&&(pBuf[3]=='k')&&(pBuf[4]=='k'))	
		{
			for(int i=5;i<iOdebrano;i++)
			{
				buf[i-5]=pBuf[i];
			}
			buf[iOdebrano-5]=NULL;
			strOdebrany=buf;
			m_ctlWyslane.AddString(strOdebrany);
			UpdateData(FALSE);
		}
	}
}

void CGniazdaDlg::OnClose()
{
	m_sGniazdoPolaczenia.Close();
	m_sGniazdoSluchajace.Close();
	m_bPolaczone=FALSE;
	GetDlgItem(IDC_EKNKAT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PWYSLIJ)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATICKNKAT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PZAMKNIJ)->EnableWindow(TRUE);
	GetDlgItem(IDC_PPOLACZ)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENAZWASWR)->EnableWindow(TRUE);
	GetDlgItem(IDC_EPORTSWR)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATICNAZWA)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATICPORT)->EnableWindow(TRUE);
	GetDlgItem(IDC_OKLIENT)->EnableWindow(TRUE);
	GetDlgItem(IDC_OSERWER)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATICTYP)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATICTYP)->ShowWindow(SW_SHOW);	
	GetDlgItem(IDC_OKLIENT)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_OSERWER)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_STATICNAZWA)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_ENAZWASWR)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_STATICPORT)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_EPORTSWR)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_STATICRAMKA)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_STATICKNKAT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EKNKAT)->EnableWindow(FALSE);
	GetDlgItem(IDC_PWYSLIJ)->EnableWindow(FALSE);
	m_strKomunikat="";
	UpdateData(FALSE);
	wyswietl=FALSE;
	CPaintDC dc(this);

	for(int i=0;i<100;i++)
	{
		wartosc_pola[i]=0;
	}
	OnInitDialog();
	Invalidate();
}

void CGniazdaDlg::OnPwyslij() 
{
	// TODO: Add your control notification handler code here
	int iDlugosc;
	int iWyslanie;
	CString temp="kkkkk";

	UpdateData(TRUE);
	temp+=m_strKomunikat;
	if(m_strKomunikat!="")
	{
		iDlugosc=temp.GetLength();
		iWyslanie=m_sGniazdoPolaczenia.Send(LPCTSTR(temp),iDlugosc);
		if(iWyslanie==SOCKET_ERROR)
		{
			MessageBox("Nie ma utworzonego polaczenia","Uwaga",MB_ICONEXCLAMATION);
		}
		else
		{		
			m_ctlWyslane.AddString(m_strKomunikat);
			UpdateData(FALSE);
		}
	}
}

void CGniazdaDlg::OnPzamknij() 
{
	// TODO: Add your control notification handler code here
	OnClose();
}

void CGniazdaDlg::RysujPola(CPaintDC *kontekst)
{
	CPoint pocz1(100,160),kon1(400,160);
	Siatka(kontekst,pocz1,kon1);
	CPoint pocz2(500,160),kon2(800,160);
	Siatka(kontekst,pocz2,kon2);	
	
}

void CGniazdaDlg::OnZamknij() 
{
	// TODO: Add your control notification handler code here
	OnOK();
}


void CGniazdaDlg::Siatka(CPaintDC *kontekst,CPoint p, CPoint k)
{
	CPoint pocz,kon;
	pocz=p;
	kon=k;
	int x,y,kodascii=65;
	char znak;

	for(int i=0;i<11;i++)
			{
				kontekst->MoveTo(pocz);
				kontekst->LineTo(kon);
				pocz.y+=30;
				kon.y+=30;
			}
		pocz.x=p.x;
		pocz.y=p.y;
		kon.x=p.x;
		kon.y=k.y+300;
		for(i=0;i<11;i++)
			{
				kontekst->MoveTo(pocz);
				kontekst->LineTo(kon);
				pocz.x+=30;
				kon.x+=30;
			}
	znak=kodascii;
	x=p.x+10;
	y=p.y-20;
	kontekst->SetBkColor(RGB(192,192,192));
	for(i=0;i<10;i++)
	{
		kontekst->TextOut(x,y,znak);
		kodascii++;
		znak=kodascii;
		x+=30;
	}
	kodascii=49;
	znak=kodascii;
	x=p.x-20;
	y=p.y+10;
	for(i=0;i<10;i++)
	{
		if(i==9)
		{
			CString z="10";
			kontekst->TextOut(x-5,y,z);
		}
		else
		{
			kontekst->TextOut(x,y,znak);
			kodascii++;
			znak=kodascii;
			y+=30;
		}
	}
	kontekst->TextOut(150,470,"Obszar dzialania twojej floty");
	kontekst->TextOut(550,470,"Obszar dzialania floty przeciwnika");
}


void CGniazdaDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CPaintDC dc(this);
	if(NastapiloPolaczenie)
	{
		if(z<20)
		{
			for(int i=0;i<100;i++)
			if((point.x>=pola[i].left)&&(point.x<=pola[i].top)
				&&(point.y>=pola[i].right)&&(point.y<=pola[i].bottom))
			{
				JakiStatekKom(z);
				if(StoiMaszt(i))
					break;
				else
					 wsplmasztow[z]=i;
			if((z==4)||(z==7)||(z==10)||(z==12)||(z==14)||(z==16)||(z==17)||(z==18)||(z==19))
			{
				if(ZaBliskoStatek(i))
					 break;
			}
		 if(CzyDowolnePole(i))
			 break;
		 else
			{
				koduj(i,2);
				if((i==90)||(i==91)||(i==92)||(i==93)||(i==94)||(i==95)||(i==96)||
					(i==97)||(i==98)||(i==99))
				{
				}
				else
				{
					koduj(i+10,1);
				}
				if((i==0)||(i==10)||(i==20)||(i==30)||(i==40)||(i==50)||(i==60)||
					(i==70)||(i==80)||(i==90))
				{
				}
				else
				{
					koduj(i-10,1);
				}
				if((i==9)||(i==19)||(i==29)||(i==39)||(i==49)||(i==59)||(i==69)||
					(i==79)||(i==89)||(i==99))
				{
				}
				else
				{
					if((i==0)||(i==10)||(i==20)||(i==30)||(i==40)||(i==50)||(i==60)||
					(i==70)||(i==80)||(i==90))
					{
					}
					else
					{
						koduj(i-9,1);
					}
					koduj(i+1,1);
					if((i==90)||(i==91)||(i==92)||(i==93)||(i==94)||(i==95)||(i==96)||
					(i==97)||(i==98)||(i==99))
					{
					}
					else
					{
						koduj(i+11,1);
					}
				}
				if((i==0)||(i==10)||(i==20)||(i==30)||(i==40)||(i==50)||(i==60)||
					(i==70)||(i==80)||(i==90))
				{
				}
				else
				{
					if((i==90)||(i==91)||(i==92)||(i==93)||(i==94)||(i==95)||(i==96)||
					(i==97)||(i==98)||(i==99))
					{
					}
					else
					{
						koduj(i+9,1);
					}
					if((i==0)||(i==10)||(i==20)||(i==30)||(i==40)||(i==50)||(i==60)||
					(i==70)||(i==80)||(i==90))
					{
					}
					else
					{
						koduj(i-11,1);
					}
					koduj(i-1,1);
				}
				z++;
				klikniecia++;
				break;
			}
		 
		}
		Invalidate();
		}
		else
		{
			Invalidate();	
		}
	}
	else
	{
		MessageBox("Nie ma polaczenia sieciowego z przeciwnikiem","Ostrzezenie",MB_ICONSTOP);
	}
	if((NastapiloPolaczenie)||(AktywnePolePrzeciwnika))
	{
		for(int i=0;i<100;i++)
		if((point.x>=TablicaPrzeciwnika[i].left)&&(point.x<=TablicaPrzeciwnika[i].top)
		&&(point.y>=TablicaPrzeciwnika[i].right)&&(point.y<=TablicaPrzeciwnika[i].bottom))
		{
			CString d;
			int z=i/10;
			int a=i-z*10;
			d.Format("%c%d",a+65,z+1);
			if(GetDlgItem(IDC_STRZALNAPOLE)->IsWindowEnabled())
			GetDlgItem(IDC_STRZALNAPOLE)->SetWindowText(d);		
		}
	}
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CGniazdaDlg::inicjuj_pola()
{
	for(int i=0;i<100;i++)
	{
		wartosc_pola[i]=0;
		TablicaPrzeciwnikaWar[i]=0;
		WartoscPolaTemp[i]=0;
		PrzeciwnikTemp[i]=0;
	}

	int o=0,j,x=101,y=161;

	for(i=0;i<10;i++)
	{
		for(j=0;j<10;j++)
		{
			pola[o].left=x;
			pola[o].top=x+28;
			pola[o].right=y;
			pola[o].bottom=y+28;
			TablicaPrzeciwnika[o].left=x+400;
			TablicaPrzeciwnika[o].top=x+428;
			TablicaPrzeciwnika[o].right=y;
			TablicaPrzeciwnika[o].bottom=y+28;
		x+=30;
		o++;
		}
		x=101;
		y+=30;
	}
}

void CGniazdaDlg::Ustaw_statki(CPaintDC *uchwyt)
{
	CString tekst;
	int x=110,y=170,o=0,i;

	CBrush tlo(RGB(255,0,0));
	o=0;
	CRect uu;

	for(i=0;i<100;i++)
	{
		if(wartosc_pola[o]==2)
		{
			uu.left=pola[o].left;
			uu.top=pola[o].right;
			uu.right=pola[o].top;	
			uu.bottom=pola[o].bottom;
			uchwyt->FillRect(uu,&tlo);
		}
		o++;
	}
	if(z==20)
	{
		MessageBox("Wszystkie statki zostaly postawione","Informacja");
		AktywnePolePrzeciwnika=TRUE;
		kom="No to do dziela 'Wilku Morski";
	}
}

void CGniazdaDlg::koduj(int numer_pola,int wartosc)
{
	if(wartosc_pola[numer_pola]!=2)
		wartosc_pola[numer_pola]=wartosc;
}



BOOL CGniazdaDlg::StoiMaszt(int numer_pola)
{
	if(wartosc_pola[numer_pola]==2)
	{
		MessageBox("Tu juz jest maszt","Ostrzezenie",MB_ICONSTOP);
		return TRUE;
	}
	return FALSE;
}

BOOL CGniazdaDlg::CzyDowolnePole(int numer_pola)
{

	if((z==0)||(z==4)||(z==7)||(z==10)||(z==12)||(z==14)||(z==16)||(z==17)||(z==18)||(z==19))
		return FALSE;
	else
	{
		if((numer_pola==wsplmasztow[z-1]+1)||(numer_pola==wsplmasztow[z-1]-1)||
		(numer_pola==wsplmasztow[z-1]+10)||(numer_pola==wsplmasztow[z-1]-10))
			return FALSE;
		else
		{
			MessageBox("Tu nie mozesz postawic masztu","Uwaga",MB_ICONINFORMATION);
			return TRUE;
		}
	}

}

BOOL CGniazdaDlg::ZaBliskoStatek(int numer_pola)
{
	if(wartosc_pola[numer_pola]==1)
	{
		MessageBox("Statek stoi za blisko","Uwaga",MB_ICONINFORMATION);
		return TRUE;
	}
	return FALSE;
}

void CGniazdaDlg::OnStrzal() 
{
	// TODO: Add your control notification handler code here
	int WyslanyStrzal,Dlugosc;
	CString pomocny="000",pomocny1;
	int strzal;

	UpdateData(TRUE);
	if(m_strStrzalNaPole!="")
	{	
		m_strStrzalNaPole.MakeUpper();
		pomocny+=m_strStrzalNaPole;
		pomocny1=m_strStrzalNaPole;
		m_strStrzalNaPole=pomocny;
		Dlugosc=m_strStrzalNaPole.GetLength();
		WyslanyStrzal=m_sGniazdoPolaczenia.Send(LPCTSTR(m_strStrzalNaPole),Dlugosc);
		if(WyslanyStrzal==SOCKET_ERROR)
		{
		}
		else
		{
			Dlugosc=pomocny1.GetLength();
			if(Dlugosc==3)
			{
				strzal=(int(pomocny1[0])-65)+90;
				if(TablicaPrzeciwnikaWar[strzal]==2)
				{
					PrzeciwnikTemp[strzal]=2;
					IleTrafionych1++;
					CzyTrafiony=TRUE;
				}
				else
				{
					PrzeciwnikTemp[strzal]=1;
					CzyTrafiony=FALSE;
				}
				Invalidate();
			}
			else
			{
				strzal=(int(pomocny1[0])-65)+(int(pomocny1[1])-49)*10;
				if(TablicaPrzeciwnikaWar[strzal]==2)
				{
					PrzeciwnikTemp[strzal]=2;
					IleTrafionych1++;
					CzyTrafiony=TRUE;
				}
				else
				{
					PrzeciwnikTemp[strzal]=1;
					CzyTrafiony=FALSE;
				}
				Invalidate();
			}
			if(IleTrafionych1==20)
				{
					MessageBox("Zwyciestwo, gratulacje!!!","Koniec");
					Wyczysc();
				}
			if(CzyTrafiony)
			{
				GetDlgItem(IDC_STRZALNAPOLE)->SetWindowText("");
				GetDlgItem(IDC_RAMKASTRZALU)->EnableWindow(TRUE);
				GetDlgItem(IDC_STRZAL)->EnableWindow(TRUE);
				GetDlgItem(IDC_NAPISSTRZALU)->EnableWindow(TRUE);
				GetDlgItem(IDC_STRZALNAPOLE)->EnableWindow(TRUE);
			}
			else
			{
				GetDlgItem(IDC_STRZALNAPOLE)->SetWindowText("");
				GetDlgItem(IDC_RAMKASTRZALU)->EnableWindow(FALSE);
				GetDlgItem(IDC_STRZAL)->EnableWindow(FALSE);
				GetDlgItem(IDC_NAPISSTRZALU)->EnableWindow(FALSE);
				GetDlgItem(IDC_STRZALNAPOLE)->EnableWindow(FALSE);	
			}
		}	
	}	
}


void CGniazdaDlg::AktywujStrzal()
{
	if(m_iTyp==1)
	{
	GetDlgItem(IDC_RAMKASTRZALU)->EnableWindow(TRUE);
	GetDlgItem(IDC_STRZAL)->EnableWindow(TRUE);
	GetDlgItem(IDC_NAPISSTRZALU)->EnableWindow(TRUE);
	GetDlgItem(IDC_STRZALNAPOLE)->EnableWindow(TRUE);
	}
	else
	{
	GetDlgItem(IDC_RAMKASTRZALU)->EnableWindow(FALSE);
	GetDlgItem(IDC_STRZAL)->EnableWindow(FALSE);
	GetDlgItem(IDC_NAPISSTRZALU)->EnableWindow(FALSE);
	GetDlgItem(IDC_STRZALNAPOLE)->EnableWindow(FALSE);
	}
	if(z!=30)
		WyslijTablice();

}

void CGniazdaDlg::WyslijTablice()
{
	char kod[2]={'a','b'};
	char *temp=new char[100]; 
	CString tab,t="tablica";
	int wyslane;

	for(int i=0;i<100;i++)
	{
		if(wartosc_pola[i]==2)
			temp[i]=kod[0];
		else
			temp[i]=kod[1];
	}
	tab=t+temp;
	int dlugosc=tab.GetLength();
	wyslane=m_sGniazdoPolaczenia.Send(LPCTSTR(tab),dlugosc);
	if(wyslane==SOCKET_ERROR)
	{
		MessageBox("Nie ma utworzonego polaczenia","Uwaga",MB_ICONEXCLAMATION);
		Wyczysc();
	}
	z=30;
}

void CGniazdaDlg::ZaznaczStrzaly(CPaintDC *uchwyt)
{
	CBrush pedzel(RGB(0,0,255));
	CRect uu;

	for(int i=0;i<100;i++)
	{
		if(WartoscPolaTemp[i]==2)
		{
			uu.left=pola[i].left;
			uu.top=pola[i].right;
			uu.right=pola[i].top;
			uu.bottom=pola[i].bottom;
			uchwyt->MoveTo(uu.left,uu.top);
			uchwyt->LineTo(uu.right,uu.bottom);
			uchwyt->MoveTo(uu.left,uu.bottom);
			uchwyt->LineTo(uu.right,uu.top);

		}
		if(WartoscPolaTemp[i]==1)
		{
			uu.left=pola[i].left;
			uu.top=pola[i].right;
			uu.right=pola[i].top;
			uu.bottom=pola[i].bottom;	
			uchwyt->Ellipse(uu);
		}
		if(PrzeciwnikTemp[i]==2)
		{
			uu.left=TablicaPrzeciwnika[i].left;
			uu.top=TablicaPrzeciwnika[i].right;
			uu.right=TablicaPrzeciwnika[i].top;
			uu.bottom=TablicaPrzeciwnika[i].bottom;
			uchwyt->FillRect(uu,&pedzel);
		}
		if(PrzeciwnikTemp[i]==1)
		{
			uu.left=TablicaPrzeciwnika[i].left;
			uu.top=TablicaPrzeciwnika[i].right;
			uu.right=TablicaPrzeciwnika[i].top;
			uu.bottom=TablicaPrzeciwnika[i].bottom;
			uchwyt->Ellipse(uu);
		}
	}

}

void CGniazdaDlg::Wyczysc()
{
	CPaintDC dc(this);

	for(int i=0;i<100;i++)
	{
		wartosc_pola[i]=0;
	}
	GetDlgItem(IDC_RAMKASTRZALU)->EnableWindow(FALSE);
	GetDlgItem(IDC_NAPISSTRZALU)->EnableWindow(FALSE);
	GetDlgItem(IDC_STRZALNAPOLE)->EnableWindow(FALSE);
	GetDlgItem(IDC_STRZAL)->EnableWindow(FALSE);
	m_strStrzalNaPole="";
	UpdateData(FALSE);
	OnClose();
	OnInitDialog();
	Invalidate();
}

void CGniazdaDlg::Komunikaty()
{
	okno->TextOut(50,525,kom);
}

void CGniazdaDlg::NapisPoPolaczeniu()
{
		CFont czcionka;
		czcionka.CreatePointFont(550,"Arial",okno);
		okno->SelectObject(&czcionka);
		okno->TextOut(110,5,"Statki");
}

void CGniazdaDlg::JakiStatekKom(int numer)
{
	if(numer==0)
		kom="Stawiasz 4-masztowca";
	if(numer==3)
		kom="Postaw pierwszego 3-masztowca";
	if(numer==4)
		kom="Stawiasz pierwszego 3-masztowca";
	if(numer==6)
		kom="Postaw drugiego 3-masztowca";
	if(numer==7)
		kom="Stawiasz drugigo 3-masztowca";
	if(numer==9)
		kom="Postaw pierwszego 2-masztowca";
	if(numer==10)
		kom="Stawiasz pierwszego 2-masztowca";
	if(numer==11)
		kom="Postaw drugiego 2-masztowca";
	if(numer==12)
		kom="Stawiasz drugigo 2-masztowca";
	if(numer==13)
		kom="Postaw trzeciego 2-masztowca";
	if(numer==14)
		kom="Stawiasz trzecigo 2-masztowca";
	if(numer==15)
		kom="Postaw cztery 1-masztowce";
}
