// GniazdaDlg.h : header file
//

#if !defined(AFX_GNIAZDADLG_H__3F904CA7_7870_11D6_AFA6_0002441281F3__INCLUDED_)
#define AFX_GNIAZDADLG_H__3F904CA7_7870_11D6_AFA6_0002441281F3__INCLUDED_

#include "MojeGniazdo.h"	// Added by ClassView
#include "Statki1.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CGniazdaDlg dialog

class CGniazdaDlg : public CDialog
{
// Construction
public:

	void OnClose();
	void OnReceive();
	void OnSend();
	void OnConnect();
	void OnAccept();
	CGniazdaDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CGniazdaDlg)
	enum { IDD = IDD_GNIAZDA_DIALOG };
	CListBox	m_ctlWyslane;
	CButton	m_ctlPolacz;
	CString	m_strKomunikat;
	CString	m_strNazwa;
	int		m_iPort;
	int		m_iTyp;
	CString	m_strStrzalNaPole;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGniazdaDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CGniazdaDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTypPo();
	afx_msg void OnPpolacz();
	afx_msg void OnPwyslij();
	afx_msg void OnPzamknij();
	afx_msg void OnZamknij();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnStrzal();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL AktywnePolePrzeciwnika;
	BOOL NastapiloPolaczenie;
	void JakiStatekKom(int numer);
	CString kom;
	BOOL wyswietl;
	void NapisPoPolaczeniu();
	CPaintDC *okno;
	void Komunikaty();
	int IleTrafionych1;
	int IleTrafionych;
	void Wyczysc();
	BOOL CzyTrafiony;
	int PrzeciwnikTemp[100];
	int WartoscPolaTemp[100];
	void ZaznaczStrzaly(CPaintDC *uchwyt);
	void WyslijTablice();
	void AktywujStrzal();
	int TablicaPrzeciwnikaWar[100];
	int CzyOddanyStrzal;
	int StrzalOddanyNaPole;
	CRect TablicaPrzeciwnika[100];
	int klikniecia;
	BOOL ZaBliskoStatek(int numer_pola);
	int z;
	int wsplmasztow[20];

	BOOL CzyDowolnePole(int numer_pola);
	BOOL StoiMaszt(int numer_pola);


	void koduj(int numer_pola,int wartosc);
	void Ustaw_statki(CPaintDC *uchwyt);
	void inicjuj_pola();
	int wartosc_pola[100];
	CRect pola[100];
	void Siatka(CPaintDC *kontekst,CPoint p,CPoint k);
	void RysujPola(CPaintDC *kontekst);
	BOOL m_bPolaczone;
	CMojeGniazdo m_sGniazdoPolaczenia;
	CMojeGniazdo m_sGniazdoSluchajace;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GNIAZDADLG_H__3F904CA7_7870_11D6_AFA6_0002441281F3__INCLUDED_)
